<script type="text/html" id="thumbview-template">
	<a class="close remove-slide">
		<span class="fa fa-trash-o"></span>
	</a>
	<a class="close duplicate-slide">
		<span class="fa fa-copy"></span>
	</a>
	<div class="drag-handle"></div>
	<div class="thumb-preview"></div>
</script>
<script type="text/html" id="layerview-template">
	<div class="layer-heading flex">
		<span class="drag-handle"></span>
		<span class="layer-icon">
			{{ if(type=="image"){ }}
				<i class="fa fa-picture-o"></i>
			{{ } else if(type == "video"){ }}
				<i class="fa fa-file-video-o"></i>
			{{ } else if(type == "text"){ }}
				<i class="fa fa-font"></i>
			{{ } }}
		</span>
		<span class="layer-toggle-button fa fa-eye enable-layer" es-enable="{{#show }}" data-tooltip="true" title="Show / hide this item"></span>
		<input type="text" class="layer-title flex-flexible" value="{{ print( content.replace(/\"/g, '\\\"') ) }}" >
		<span class="layer-toggle-button fa fa-lock lock-layer" es-enable="{{# lock }}" data-tooltip="true" title="Lock / unlock this item"></span>
	</div>
	<div class="layer-timeline flex-flexible">
		<div class="timeline-duration">
			<div class="timeline-in">
				<div class="timeline-effect-name" data-tooltip="true" title="Click to change build in effect">{{# build.inEffect }}</div>
			</div>
			<div class="timeline-out">
				<div class="timeline-effect-name" data-tooltip="true" title="Click to change build out effect">{{# build.outEffect }}</div>
			</div>
		</div>
	</div>
	<div class="layer-end">
		<span class="duplicate-layer fa fa-copy" data-tooltip="true" title="Duplicate this item"></span><!--
		--><span class="delete-layer fa fa-trash" data-tooltip="true" title="Delete this item"></span>
	</div>
</script>
<script type="text/html" id="slideview-template">
	<div class="jsn-es-canvas-wrapper flex-flexible">
		<div class="jsn-es-canvas-ruler"></div>
		<div class="jsn-es-canvas-background">
			<div class="jsn-es-canvas-markers"></div>
			<div class="jsn-es-canvas-mask"></div>
			<div class="jsn-es-canvas-behind"></div>
			<div class="jsn-es-canvas"></div>
			<div class="jsn-es-canvas-preview hidden"></div>
		</div>
		<div class="jsn-es-canvas-panner hidden"></div>
		<div class="jsn-es-canvas-locator hidden"></div>
	</div>
	<div class="jsn-es-layers-wrapper">
		<div class="jsn-es-timeline-slider flex flex-layout">
			<div class="slider-heading">
				Layers
			</div>
			<div class="slider-track-wrapper flex-flexible">
				<canvas class="ruler"></canvas>
				<div class="slider-track">
					<div class="ui-slider-handle">
						<svg width="17" height="35">
							<path class="button" d="M0 2 L2 0 L14 0 L16 2 L16 12 L9 20 L8 20 L0 12 Z"></path>
							<path class="line2" d="M5 7 L13 7 M5 10 L13 10"></path>
							<path class="line" d="M4 6 L12 6 M4 9 L12 9"></path>
						</svg>
					</div>
				</div>
			</div>
			<div class="timeline-toolset">
				<a class="btn btn-default btn-xs decrease-time" data-tooltip="true" title="Decrease time">
					<span class="fa fa-minus"></span>
				</a>
				<a class="btn btn-default btn-xs increase-time" data-tooltip="true" title="Increase time">
					<span class="fa fa-plus"></span>
				</a>
			</div>
		</div>
		<div class="jsn-es-layers-scroll-wrap">
			<div class="jsn-es-timeline-guide"></div>
			<div class="jsn-es-layers"></div>
		</div>
	</div>
</script>
<script type="text/html" id="itemview-template">
	<div class="item-origin jsn-es-animated" title="Drag me to set item origin">
		<div class="item-origin-handle">
			<svg width="50" height="50">
				<path d="M32,25c0,3.9-3.1,7-7,7s-7-3.1-7-7s3.1-7,7-7S32,21.1,32,25z M25,14V7 M36,25h7 M14,25H7 M25,36v7 M25,21c-2.2,0-4,1.8-4,4s1.8,4,4,4s4-1.8,4-4S27.2,21,25,21z"/>
			</svg>
		</div>
	</div>
	<div class="item-container {{# type }}">
		{{ if ( type == 'text' || type == 'html' ) { }}
		<div class="text-editor"></div>
		{{ } }}
	</div>
	{{ if(type == 'image'){ }}
	<div class="crop-container hidden">
		<div class="crop-area"></div>
	</div>
	<div class="upload-container hidden">
		<div class="progress">
			<div class="progress-bar" style="width: 0%;"></div>
		</div>
	</div>
	{{ } }}
	<div class="preview-container"></div>
</script>
<script type="text/html" id="template-item-template">
	<div class="item-container {{# type }}">
		{{ if(type == 'text'){ }}
		<div class="text-editor"></div>
		{{ } }}
	</div>
</script>
<script type="text/html" id="media-selector-file-template">
	<a href="{{# filename }}" class="{{# type }}">
		<div class="file-icon"></div>
		<div class="file-name">
			{{# filename }}
		</div>
	</a>
</script>
<script type="text/html" id="text-shadow-item-template">
	<div class="row flex flex-layout">
		<div class="col-xs-4 flex-flexible">
			<input type="text" class="form-control input-sm input-number value-x" value="{{# x }}" data-tooltip="true" title="Shadow Offset X (px)">
		</div>
		<div class="col-xs-4 flex-flexible">
			<input type="text" class="form-control input-sm input-number value-y" value="{{# y }}" data-tooltip="true" title="Shadow Offset Y (px)">
		</div>
		<div class="col-xs-4 flex-flexible">
			<input type="text" class="form-control input-sm input-number value-blur" value="{{# blur }}" data-tooltip="true" title="Shadow Blur (px)">
		</div>
		<div class="col-xs-4 flex-flexible">
			<input type="text" class="form-control input-sm input-color value-color" value="{{# color }}" data-tooltip="true" title="Shadow Color">
		</div>
		<div>
			<a class="btn btn-default btn-sm remove-shadow" data-tooltip="true" title="Remove this shadow">
				<span class="fa fa-trash-o"></span>
			</a>
		</div>
	</div>
</script>
<script type="text/html" id="box-shadow-item-template">
	<div class="row flex flex-layout">
		<div class="col-xs-4 flex-flexible">
			<select class="form-control input-sm value-inset" data-tooltip="true" title="Shadow inset or outset">
				<option value="">out</option>
				<option value="inset" {{ if (inset == 'inset') print("selected") }}>in</option>
			</select>
		</div>
		<div class="col-xs-4 flex-flexible">
			<input type="text" class="form-control input-sm input-number value-x" value="{{# x }}" data-tooltip="true" title="Shadow Offset X (px)">
		</div>
		<div class="col-xs-4 flex-flexible">
			<input type="text" class="form-control input-sm input-number value-y" value="{{# y }}" data-tooltip="true" title="Shadow Offset Y (px)">
		</div>
		<div class="col-xs-4 flex-flexible">
			<input type="text" class="form-control input-sm input-number value-blur" value="{{# blur }}" data-tooltip="true" title="Shadow Blur (px)">
		</div>
		<div class="col-xs-4 flex-flexible">
			<input type="text" class="form-control input-sm input-color value-color" value="{{# color }}" data-tooltip="true" title="Shadow Color">
		</div>
		<div>
			<a class="btn btn-default btn-sm remove-shadow" data-tooltip="true" title="Remove this shadow">
				<span class="fa fa-trash-o"></span>
			</a>
		</div>
	</div>
</script>

<script type="text/html" id="jsn-es-item-template">
	<div class="item-content">{{#content}}</div>
</script>