<style>
	.jsn-es-slider {
		display: inline-block;
		position: relative;

		margin: auto;
		max-width: auto;
		max-height: auto;

		overflow: hidden;
	}

	.jsn-es-slide {
		display: block;
		position: absolute;

		width: 100%;
		height: 100%;
	}

	.jsn-es-container {
		display: block;
		position: relative;

		top: 50%;
		left: 50%;
		margin: auto;
		background-color: rgba(255, 255, 255, 0.2);
	}

	.jsn-es-item {
		display: inline-block;
		position: absolute;

		width: auto;
		height: auto;
	}
</style>

<!-- Main slider element -->
<div class="jsn-es-slider" id="slider1"

	 data-mode="1"

	 data-width="100%"
	 data-height="300px"

	 data-max-width=""
	 data-max-height=""

	 data-container-width="600px"
	 data-container-height="400px"

	 data-full-width="true"
	 data-full-height="true"
	>

	<!-- Slide element -->
	<div class="jsn-es-slide"
		 data-delay="5"
		 data-bg-color="#CCC"
		>

		<div class="jsn-es-container">

			<!-- Text layer element -->
			<h3 class="jsn-es-item hidden"

				data-type="text"

				data-origin="0,0"

				data-style='{"top":"10%","left":"10%","background":"blue","padding":"5px"}'
				data-style-T="{}"
				data-style-M="{}"

				data-fx-in-delay="0"
				data-fx-in-duration="1000"
				data-fx-in-fade="true"
				data-fx-in-timing="ease"
				data-fx-in-transform="x:-200;r:45;"

				data-fx-out-delay="3000"
				data-fx-out-duration="1000"
				data-fx-out-fade="true"
				data-fx-out-timing="ease"
				data-fx-out-transform="y:200;r:-135;"
				>
				Heading 3
			</h3>

			<h1 class="jsn-es-item"
				data-type="text"
				data-origin="0.5,0.5"
				data-style='{"top":"40%","left":"50%","width":"320px","textAlign":"center"}'
				>
				This is some title
			</h1>

			<p class="jsn-es-item"
			   data-type="text"
			   data-origin="0.5,0.5"
			   data-style='{"top":"50%","left":"50%"}'
				>
				This is some description text
			</p>

			<h1 class="jsn-es-item"
				data-type="text"
				data-origin="1,0"
				data-style='{"top":"0%","left":"100%","width":"auto"}'
				>
				Corner
			</h1>

			<h3 class="jsn-es-item"
				data-type="text"
				data-origin="0,1"
				data-style='{"top":"100%","left":"0%"}'
				>
				Another text
			</h3>
			<button class="jsn-es-item"
					data-type="text"
					data-origin="0.5,0.5"
					data-style='{"top":"70%","left":"50%"}'
				>
				Button
			</button>
			<img class="jsn-es-item"
				 src="http://wtht.nh1media.com/assets/images/Hello-Kitty-psd26128.png"
				 data-type="image"
				 data-origin="0.5,0.5"
				 data-style='{"top":"50%","left":"20%","width":"100px","height":"122px"}'
				/>
		</div>

	</div>

</div>

<?php JSNHtmlAsset::addScript(JSNES_PLG_SYSTEM_ASSETS_URL . 'lib/underscore/underscore.js'); ?>
<?php JSNHtmlAsset::addScript(JSNES_PLG_SYSTEM_ASSETS_URL . 'lib/jquery/jquery.min.js'); ?>
<?php JSNHtmlAsset::addScript(JSNES_PLG_SYSTEM_ASSETS_URL . 'lib/backbone/backbone.js'); ?>

<script>

	var JSNEasySlider = Backbone.View.extend( {
		constructor: function JSNEasySlider() {
			Backbone.View.apply( this, arguments );
		},
		initialize: function () {
			this.slides = [];

			this.width = this.$el.attr( 'data-width' );
			this.height = this.$el.attr( 'data-height' );

			this.maxWidth = this.$el.attr( 'data-max-width' );
			this.maxHeight = this.$el.attr( 'data-max-height' );

			this.containerWidth = this.$el.attr( 'data-container-width' ) || '100%';
			this.containerHeight = this.$el.attr( 'data-container-height' ) || '100%';

			this.fullHeight = this.$el.attr( 'data-full-height' );

			this.$( '.jsn-es-slide' ).each( _.bind( function ( i, el ) {
				this.slides.push( new JSNEasySlider_Slide( {
					el: el,
					slider: this
				} ) );
			}, this ) );

			$( window ).resize( _.bind( this.resize, this ) );
		},
		resize: function () {
			if ( this.fullHeight ) {
				this.height = window.innerHeight - 150;
				this.render();
			}
		},
		render: function () {
			this.$el
				.width( this.width )
				.height( this.height )
				.css( {
					maxWidth: this.maxWidth,
					maxHeight: this.maxHeight,
				} );
			_( this.slides ).invoke( 'render' );
		}
	} );

	var JSNEasySlider_Slide = Backbone.View.extend( {
		constructor: function JSNEasySlider_Slide() {
			Backbone.View.apply( this, arguments );
		},
		initialize: function ( options ) {
			this.slider = options.slider;
			this.items = [];
			this.$container = this.$( '.jsn-es-container' )
			this.backgroundColor = this.$el.attr( 'data-bg-color' );

			this.$( '.jsn-es-item' ).each( _.bind( function ( i, el ) {
				this.items.push( new JSNEasySlider_Item( {
					el: el,
					slide: this
				} ) );
			}, this ) );
		},
		render: function () {
			this.$el.css( {
				backgroundColor: this.backgroundColor
			} );
			this.$container
				.width( this.slider.containerWidth )
				.height( this.slider.containerHeight )
				.css( {
					marginLeft: this.$container.width() / -2 + 'px',
					marginTop: this.$container.height() / -2 + 'px',
				} );
			_( this.items ).invoke( 'render' );
		}
	} );

	var JSNEasySlider_Item = Backbone.View.extend( {
		constructor: function JSNEasySlider_Item() {
			Backbone.View.apply( this, arguments );
		},
		initialize: function ( options ) {

			this.slide = options.slide;
			this.type = this.$el.attr( 'data-type' );

			this.origin = this.$el.attr( 'data-origin' ).split( ',' ).map( function ( value ) {
				return parseFloat( value )
			} );

			this.style = JSON.parse( this.$el.attr( 'data-style' ) || '{}' );
			this.styleT = JSON.parse( this.$el.attr( 'data-style-T' ) || '{}' );
			this.styleM = JSON.parse( this.$el.attr( 'data-style-M' ) || '{}' );
		},
		getStyle: function () {
			return this.style;
		},
		render: function () {
			this.$el
				.addClass( 'jsn-es-item-' + this.type )
				.css( this.getStyle() );
			this.$el
				.css( {
					marginLeft: -this.$el.outerWidth() * this.origin[ 0 ] + 'px',
					marginTop: -this.$el.outerHeight() * this.origin[ 1 ] + 'px',
				} );
		}
	} );

	s1 = new JSNEasySlider( { el: '#slider1' } );
	s1.render();

</script>